{{  XBeeAux110303a

  Modified from MultiRxTxFlags110227f
  Instead of having two versions of four port serial
  object called from top object.  Call at least one
  of them from a child object.
  110301c works okay.
  
}}
CON

  '_clkmode = xtal1 + pll16x
  '_xinfreq = 5_000_000

  '' Pin asignments
  _LargeBalancePinRx = 3        ' I connect this pin with _AnalyticalBalancePinTx (through 2k resistor)
  _LargeBalancePinTx = 2        ' I connect this pin with _SpectrometerPinRx (through 2k resistor) 
  _AnalyticalBalancePinRx = 1   ' I connect this pin with _SpectrometerPinTx (through 2k resistor)  
  _AnalyticalBalancePinTx = 0  
  _SpectrometerPinRx = 5
  _SpectrometerPinTx = 4
  _XBee0RxPin = 7
  _XBee0TxPin = 6
  _XBee0CtsPin = 12
  _XBee0RtsPin = 13
  _XBee1RxPin = 9
  _XBee1TxPin = 8
  _XBee1CtsPin = -1 '14 '
  _XBee1RtsPin = -1 '15
  _Debug1RxPin = 11
  _Debug1TxPin = 10
  _LedPin = 23

  _RtsThreshold = 0 '495
  
  _DebugBaud = 57600 '9600 4800 '   
  _Debug1Baud = 57600               
  _AnalyticalBalanceBaud = 57600 '4800 4800 '
  _LargeBalanceBaud = 57600 '2400 4800 '
  _SpectrometerBaud = 57600 '1200 4800 '
  _XBeeBaud = 9600
 

  ' Com enumeration
  #0, _XBeeCom, _DebugCom, _SpectrometerCom

  WirelessCom = _XBeeCom
   
VAR

  long rxFlag[4], oldRxFlag[4]
  'long rxFlag1[4], oldRxFlag1[4]
  long AuxStack[100]
  long flag2Address
  byte endChar
  'byte txCount0, comAcknowledgeFlag
  'byte txCount1, auxAcknowledgeFlag
  byte setCount[6]
  byte acknowledgeFlag[6]
  byte xbeeSettings[2], wirelessReadyFlag
  byte linesToExpectCom[4], endOfTransExceptionFlag, tempBuffer[Header#_LargeBufferSize]
  
OBJ

  Com : "pcFullDuplexSerial4FC512FlagsPlus110304a2"
  Header : "Header110228a"
  
PUB Start(addressOfFlag2)

  flag2Address := addressOfFlag2
  result := cognew(Main, @AuxStack)
  
PUB Main | count[14], localIndex, localCharacter, localCount

  
  endChar := 13
  linesToExpectCom[_XBeeCom] := 1
  linesToExpectCom[_DebugCom] := 1
  linesToExpectCom[_SpectrometerCom] := 1
  linesToExpectCom[3] := 1
  
  count[0] := Com.Init      
  count[1] := Com.AddPort(_XBeeCom, _XBee1RxPin, _XBee1TxPin, _XBee1CtsPin, _XBee1RtsPin, _RtsThreshold, 0, _XBeeBaud) 
  count[2] := Com.AddPort(_DebugCom, _Debug1RxPin, _Debug1TxPin, -1, -1, 0, 0, _Debug1Baud) 
  count[3] := Com.AddPort(_SpectrometerCom, _SpectrometerPinRx, _SpectrometerPinTx, -1, -1, 0, 0, _SpectrometerBaud)
  'count[4] := Com.AddPort(_LargeBalanceCom, _LargeBalancePinRx, _LargeBalancePinTx, -1, -1, 0, 0, _LargeBalanceBaud)
  'Com.SetFlags(endChar, @rxFlag1[0], @setCount[Header#_Sam], @acknowledgeFlag[Header#_Sam])
  Com.SetFlags(endChar, @rxFlag[0], @setCount[Header#_Coordinator], @acknowledgeFlag[Header#_Coordinator]) 
  count[5] := Com.Start           
  
 

  ' Uncomment section in AddPort method to have buffer addresses returned.
  
  repeat localIndex from 0 to 13
    Com.str(_DebugCom, string(13, "count["))
    Com.dec(_DebugCom, localIndex)
    Com.str(_DebugCom, string("] = "))
    Com.dec(_DebugCom, count[localIndex])
  {**110304**
  repeat
    repeat
      result := DisplayXBeeSettings
      localCount++
    while result == 0 and localCount < Header#_XBeeSettingsAttempts
    if result == 0
      Com.str(_DebugCom, string(13, "Unable to communicate"))
      Com.str(_DebugCom, string(13, "with XBee"))
      Com.str(_DebugCom, string(13, "Attempts = "))
      Com.dec(_DebugCom, localCount)
    else
      xbeeSettings[Header#_AttachedSerial] := FindXBeeSetting(Header#_AttachedSerial)
      if xbeeSettings[Header#_AttachedSerial] == -1
        Com.str(_DebugCom, string(13, "Attached serial number not found in the list."))
      else
        wirelessReadyFlag[Header#_AttachedSerial] := 1
        Com.str(_DebugCom, string(13, "Attached serial number was found."))
        if xbeeSettings[Header#_AttachedSerial] <> Header#_Sam
          
          Com.str(_DebugCom, string(13, "The serial number was not the one expected."))
        else
          Com.str(_DebugCom, string(13, "The serial number matches the one expected."))
        waitcnt(clkfreq * 2 + cnt)
        Com.str(_DebugCom, string(13, "The attached XBee is number "))
        Com.dec(_DebugCom, xbeeSettings[Header#_AttachedSerial])
        Com.str(_DebugCom, string(13, "The XBee's name is "))
        Com.str(_DebugCom, @xbeeNames + (xbeeSettings[Header#_AttachedSerial] * Header#_XBeeNameFieldSize))
      waitcnt(clkfreq * 2 + cnt)               
      xbeeSettings[Header#_TargetSerial] := FindXBeeSetting(Header#_TargetSerial)
      if xbeeSettings[Header#_TargetSerial] == -1
        Com.str(_DebugCom, string(13, "The target's serial number not found in the list."))
      else
        wirelessReadyFlag[Header#_TargetSerial] := 1
        Com.str(_DebugCom, string(13, "The target's serial number was found."))
        if xbeeSettings[Header#_TargetSerial] <> Header#_Coordinator
          
          Com.str(_DebugCom, string(13, "The serial number was not the one expected."))
          SetTarget(Header#_Coordinator)
        else
          Com.str(_DebugCom, string(13, "The serial number matches the one expected."))
        waitcnt(clkfreq * 2 + cnt)
        Com.str(_DebugCom, string(13, "The target XBee is number "))
        Com.dec(_DebugCom, xbeeSettings[Header#_TargetSerial])
        Com.str(_DebugCom, string(13, "The target XBee's name is "))
        Com.str(_DebugCom, @xbeeNames + (xbeeSettings[Header#_TargetSerial] * Header#_XBeeNameFieldSize))
      waitcnt(clkfreq * 2 + cnt)
  while xbeeSettings[Header#_TargetSerial] <> Header#_Coordinator
  **110304**}
  repeat count[0] from {12} 3 to 1                      ' Use 12 seconds if using XBees since it 
    Com.str(_DebugCom, string(13, "Tx in "))            ' can take a while set the target XBee.
    Com.dec(_DebugCom, count[0])
    Com.str(_DebugCom, string(" seconds."))
    waitcnt(clkfreq + cnt) 
  count[0] := 0
  repeat
    
    count[0]++
    if count[0] // 64 == 0
      Com.str(_SpectrometerCom, @spectrometerOutput1)
      'Com.str(_DebugCom, string(13, "flag2 = ")) 
      'Com.dec(_DebugCom, byte[flag2Address])  
      Com.tx(_DebugCom, 13)
      Com.str(_SpectrometerCom, @spectrometerOutput2)
      'Com.str(_DebugCom, string(13, "flag2 = ")) 
      'Com.dec(_DebugCom, byte[flag2Address])  
      Com.tx(_DebugCom, 13)
      Com.str(_SpectrometerCom, @spectrometerOutput3)
      'Com.str(_DebugCom, string(13, "flag2 = ")) 
      'Com.dec(_DebugCom, byte[flag2Address])  
      Com.tx(_DebugCom, 13)
      Com.str(_SpectrometerCom, @spectrometerOutput4)
      'Com.str(_DebugCom, string(13, "flag2 = ")) 
      'Com.dec(_DebugCom, byte[flag2Address])  
      Com.tx(_DebugCom, 13)
      Com.str(_SpectrometerCom, @spectrometerOutput5)
      'Com.str(_DebugCom, string(13, "flag2 = ")) 
      'Com.dec(_DebugCom, byte[flag2Address])  
      Com.tx(_DebugCom, 13)
      Com.str(_SpectrometerCom, @spectrometerOutput6)
      'Com.str(_DebugCom, string(13, "flag2 = ")) 
      'Com.dec(_DebugCom, byte[flag2Address])  
      Com.tx(_DebugCom, 13)
      Com.str(_SpectrometerCom, @spectrometerOutput7)
      'Com.str(_DebugCom, string(13, "flag2 = ")) 
      'Com.dec(_DebugCom, byte[flag2Address])  
      Com.tx(_DebugCom, 13)
      Com.str(_SpectrometerCom, @spectrometerOutput8)
      'Com.str(_DebugCom, string(13, "flag2 = ")) 
      'Com.dec(_DebugCom, byte[flag2Address])  
      Com.tx(_DebugCom, 13)
      Com.str(_SpectrometerCom, @spectrometerOutput9)
      'Com.str(_DebugCom, string(13, "flag2 = ")) 
      'Com.dec(_DebugCom, byte[flag2Address])  
      Com.tx(_DebugCom, 13)
      Com.str(_SpectrometerCom, @spectrometerOutput10) 
      'Com.str(_DebugCom, string(13, "flag2 = ")) 
      'Com.dec(_DebugCom, byte[flag2Address])  
      Com.tx(_DebugCom, 13)
      Com.str(_DebugCom, @spectrometerOutput1)
    
    
    if count[0] // 4 == 2
      TransmitString(Header#_Sam, Header#_Coordinator, @xbee1Output1)
      FlushBuffer(_XBeeCom)
      TransmitString(Header#_Sam, Header#_Coordinator, @xbee1Output2)
      FlushBuffer(_XBeeCom)
      TransmitString(Header#_Sam, Header#_Coordinator, @xbee1Output3)
      FlushBuffer(_XBeeCom)
      TransmitString(Header#_Sam, Header#_Coordinator, @xbee1Output4)
      FlushBuffer(_XBeeCom)
      TransmitString(Header#_Sam, Header#_Coordinator, @xbee1Output5)
      FlushBuffer(_XBeeCom)
      
    { TransmitString(Header#_Sam, Header#_Coordinator, @xbee1Output6) 
      TransmitString(Header#_Sam, Header#_Coordinator, @xbee1Output7)
      TransmitString(Header#_Sam, Header#_Coordinator, @xbee1Output8)
      TransmitString(Header#_Sam, Header#_Coordinator, @xbee1Output9)
      TransmitString(Header#_Sam, Header#_Coordinator, @xbee1Output10) }
      Com.str(_DebugCom, @xbee1Output1) 
    repeat localIndex from 0 to 2
      {Com.str(_DebugCom, string(13, "rxFlag["))
      Com.dec(_DebugCom, localIndex)
      Com.str(_DebugCom, string("] = "))
      Com.dec(_DebugCom, rxFlag[localIndex])
      'Com.tx(_DebugCom, 13)
      'Com.str(_DebugCom, string(", flag2 = "))
      'Com.dec(_DebugCom, byte[flag2Address])  
      Com.tx(_DebugCom, 13)                      }
        
      repeat while rxFlag[localIndex] <> oldRxFlag[localIndex]
        {Com.str(_DebugCom, string(13, "("))
        Com.dec(_DebugCom, localIndex)
        Com.tx(_DebugCom, 44)  
        Com.tx(_DebugCom, 32)  
        Com.dec(_DebugCom, rxFlag[localIndex])
        Com.tx(_DebugCom, 44)  
        Com.tx(_DebugCom, 32)  
        Com.dec(_DebugCom, oldRxFlag[localIndex])
        Com.str(_DebugCom, string(")", 13)) }
        FlushBuffer(localIndex)  
        
    waitcnt(clkfreq / 8 + cnt)
      
PUB SetTarget(localTargetXbee) | tempPtr[2], localCount

  Com.str(_DebugCom, string("SetTarget method.", 13))

  tempPtr[0] := @slCoordinator + (localTargetXbee * (Header#_XBeeSerialSize + 1))
  tempPtr[1] := @shCoordinator + (localTargetXbee * (Header#_XBeeSerialSize + 1))

  
  repeat while rxFlag[_XBeeCom] <> oldRxFlag[_XBeeCom]
    Com.str(_DebugCom, string("rxFlag is not equal to oldRxFlag", 13))
    FlushBuffer(_XBeeCom)

  Com.str(_DebugCom, string("The Propeller chip will communicate", 13))
  Com.str(_DebugCom, string("with the XBee in three seconds.", 13))
  waitcnt(clkfreq + cnt) 
  Com.str(_DebugCom, string("Two seconds", 13))
  waitcnt(clkfreq + cnt) 
  Com.str(_DebugCom, string("One second", 13))
  waitcnt(clkfreq + cnt) 
  Com.str(_DebugCom, string(13, "+++", 13))
  repeat while rxFlag[_XBeeCom] <> oldRxFlag[_XBeeCom]
    FlushBuffer(_XBeeCom)
    
  localCount := cnt
  Com.str(_XBeeCom, string("+++"))
  ' This delay needs to be at least as long as the Guard Time (default 1.0 second)
  repeat while rxFlag[_XBeeCom] == oldRxFlag[_XBeeCom] and Header#_XBeeTimeout => cnt - localCount
  if rxFlag[_XBeeCom] == oldRxFlag[_XBeeCom]
    Com.str(_DebugCom, string("Time Out 3+", 13))
    return 0

  Com.str(_DebugCom, string(13, "DH = ")) ' Destination High
  Com.str(_DebugCom, tempPtr[1]) ' Destination High
  Com.tx(_DebugCom, 13)
  repeat while rxFlag[_XBeeCom] <> oldRxFlag[_XBeeCom]
    FlushBuffer(_XBeeCom)
    
  localCount := cnt
  Com.str(_XBeeCom, string("ATDH "))
  Com.str(_XBeeCom, tempPtr[1])
  Com.tx(_XBeeCom, 13) 
  repeat while rxFlag[_XBeeCom] == oldRxFlag[_XBeeCom] and Header#_XBeeTimeout => cnt - localCount 
  if rxFlag[_XBeeCom] == oldRxFlag[_XBeeCom]
    Com.str(_DebugCom, string("Time Out stdh", 13))
    return 0
    
  repeat while rxFlag[_XBeeCom] <> oldRxFlag[_XBeeCom]
    FlushBuffer(_XBeeCom)
 
  
  Com.str(_DebugCom, string(13, "DL = ")) ' Destination Low
  Com.str(_DebugCom, tempPtr[0])
  Com.tx(_DebugCom, 13) 
  repeat while rxFlag[_XBeeCom] <> oldRxFlag[_XBeeCom]
    FlushBuffer(_XBeeCom)
    
  localCount := cnt
  Com.str(_XBeeCom, string("ATDL "))
  Com.str(_XBeeCom, tempPtr[0])
  Com.tx(_XBeeCom, 13) 
  repeat while rxFlag[_XBeeCom] == oldRxFlag[_XBeeCom] and Header#_XBeeTimeout => cnt - localCount 
  if rxFlag[_XBeeCom] == oldRxFlag[_XBeeCom]
    Com.str(_DebugCom, string("Time Out atdl", 13))
    return 0
    
  repeat while rxFlag[_XBeeCom] <> oldRxFlag[_XBeeCom]
    FlushBuffer(_XBeeCom)

  Com.str(_DebugCom, string(13, "Checking CTS with ATD7", 13)) ' Destination Low
  'Com.str(_DebugCom, tempPtr[0])
  'Com.tx(_DebugCom, 13) 
  repeat while rxFlag[_XBeeCom] <> oldRxFlag[_XBeeCom]
    FlushBuffer(_XBeeCom)
    
  localCount := cnt
  Com.str(_XBeeCom, string("ATD7 "))
  'Com.str(_XBeeCom, tempPtr[0])
  Com.tx(_XBeeCom, 13) 
  repeat while rxFlag[_XBeeCom] == oldRxFlag[_XBeeCom] and Header#_XBeeTimeout => cnt - localCount 
  if rxFlag[_XBeeCom] == oldRxFlag[_XBeeCom]
    Com.str(_DebugCom, string("Time Out atd7", 13))
    return 0
    
  repeat while rxFlag[_XBeeCom] <> oldRxFlag[_XBeeCom]
    FlushBuffer(_XBeeCom)
  
  
  Com.str(_DebugCom, string(13, "End Command Mode"))
  repeat while rxFlag[_XBeeCom] <> oldRxFlag[_XBeeCom]
    FlushBuffer(_XBeeCom)
    
  localCount := cnt
  Com.str(_XBeeCom, string("ATCN "))
  Com.tx(_XBeeCom, 13) 
  repeat while rxFlag[_XBeeCom] == oldRxFlag[_XBeeCom] and Header#_XBeeTimeout => cnt - localCount
  if rxFlag[_XBeeCom] == oldRxFlag[_XBeeCom]
    Com.str(_DebugCom, string("Time Out atcn", 13))
    return 0

  repeat while rxFlag[_XBeeCom] <> oldRxFlag[_XBeeCom]
    FlushBuffer(_XBeeCom)
  result := 1
      
PUB DisplayXBeeSettings | localCount
'' This method needs to be called before MainLoop method or from the same cog as MainLoop.
'' WatchCom should be running in a separate cog to set rxFlag.

  repeat while rxFlag[_XBeeCom] <> oldRxFlag[_XBeeCom]
    Com.str(_DebugCom, string("rxFlag is not equal to oldRxFlag", 13))
    FlushBuffer(_XBeeCom)

  Com.str(_DebugCom, string("The Propeller chip will communicate", 13))
  Com.str(_DebugCom, string("with the XBee in three seconds.", 13))
  waitcnt(clkfreq + cnt) 
  Com.str(_DebugCom, string("Two seconds", 13))
  waitcnt(clkfreq + cnt) 
  Com.str(_DebugCom, string("One second", 13))
  waitcnt(clkfreq + cnt) 
  Com.str(_DebugCom, string(13, "+++", 13))
  repeat while rxFlag[_XBeeCom] <> oldRxFlag[_XBeeCom]
    FlushBuffer(_XBeeCom)
    
  localCount := cnt
  Com.str(_XBeeCom, string("+++"))
  ' This delay needs to be at least as long as the Guard Time (default 1.0 second)
  repeat while rxFlag[_XBeeCom] == oldRxFlag[_XBeeCom] and Header#_XBeeTimeout => cnt - localCount
  if rxFlag[_XBeeCom] == oldRxFlag[_XBeeCom]
    Com.str(_DebugCom, string("Time Out 3+", 13))
    return 0
    
  repeat while rxFlag[_XBeeCom] <> oldRxFlag[_XBeeCom]
    FlushBuffer(_XBeeCom)
  Com.str(_DebugCom, string(" SH = ")) ' Serial Number High
  repeat while rxFlag[_XBeeCom] <> oldRxFlag[_XBeeCom]
    FlushBuffer(_XBeeCom)
    
  localCount := cnt
  Com.str(_XBeeCom, string("ATSH"))
  Com.tx(_XBeeCom, 13)
  repeat while rxFlag[_XBeeCom] == oldRxFlag[_XBeeCom] and Header#_XBeeTimeout => cnt - localCount
  if rxFlag[_XBeeCom] == oldRxFlag[_XBeeCom]
    Com.str(_DebugCom, string("Time Out atsh", 13))
    return 0
    
  repeat while rxFlag[_XBeeCom] <> oldRxFlag[_XBeeCom]
    FlushBuffer(_XBeeCom)
  localCount := ZeroPadString(@tempBuffer, Header#_XBeeSerialSize)
  if localCount > 0
    Com.str(_DebugCom, string(" SH = "))
    SafeBug(@tempBuffer, 8)
  tempBuffer[Header#_XBeeSerialSize] := 0              
  StringCopy(@shAttached, @tempBuffer)
  
  Com.str(_DebugCom, string(13, "SL = ")) ' Serial Number Low
  repeat while rxFlag[_XBeeCom] <> oldRxFlag[_XBeeCom]
    FlushBuffer(_XBeeCom)
    
  localCount := cnt
  Com.str(_XBeeCom, string("ATSL "))
  Com.tx(_XBeeCom, 13) 
  repeat while rxFlag[_XBeeCom] == oldRxFlag[_XBeeCom] and Header#_XBeeTimeout => cnt - localCount
  if rxFlag[_XBeeCom] == oldRxFlag[_XBeeCom]
    Com.str(_DebugCom, string("Time Out atsl", 13))
    return 0
    
  repeat while rxFlag[_XBeeCom] <> oldRxFlag[_XBeeCom]
    FlushBuffer(_XBeeCom)
  localCount := ZeroPadString(@tempBuffer, Header#_XBeeSerialSize)
  if localCount > 0
    Com.str(_DebugCom, string(" SL = "))
    SafeBug(@tempBuffer, 8)
  tempBuffer[Header#_XBeeSerialSize] := 0
  StringCopy(@slAttached, @tempBuffer)
  
  Com.str(_DebugCom, string(13, "DH = ")) ' Destination High
  repeat while rxFlag[_XBeeCom] <> oldRxFlag[_XBeeCom]
    FlushBuffer(_XBeeCom)
    
  localCount := cnt
  Com.str(_XBeeCom, string("ATDH "))
  Com.tx(_XBeeCom, 13) 
  repeat while rxFlag[_XBeeCom] == oldRxFlag[_XBeeCom] and Header#_XBeeTimeout => cnt - localCount 
  if rxFlag[_XBeeCom] == oldRxFlag[_XBeeCom]
    Com.str(_DebugCom, string("Time Out stdh", 13))
    return 0
    
  repeat while rxFlag[_XBeeCom] <> oldRxFlag[_XBeeCom]
    if rxFlag[_XBeeCom] <> oldRxFlag[_XBeeCom]
      Com.str(_DebugCom, string("rxFlag[_XBeeCom] greater than 1 (atdh)", 13))
    FlushBuffer(_XBeeCom)
  localCount := ZeroPadString(@tempBuffer, Header#_XBeeSerialSize)
  if localCount > 0
    Com.str(_DebugCom, string(" DH = "))
    SafeBug(@tempBuffer, 8)
  tempBuffer[Header#_XBeeSerialSize] := 0
  StringCopy(@shDestination, @tempBuffer)
  
  Com.str(_DebugCom, string(13, "DL = ")) ' Destination Low
  repeat while rxFlag[_XBeeCom] <> oldRxFlag[_XBeeCom]
    FlushBuffer(_XBeeCom)
    
  localCount := cnt
  Com.str(_XBeeCom, string("ATDL "))
  Com.tx(_XBeeCom, 13) 
  repeat while rxFlag[_XBeeCom] == oldRxFlag[_XBeeCom] and Header#_XBeeTimeout => cnt - localCount 
  if rxFlag[_XBeeCom] == oldRxFlag[_XBeeCom]
    Com.str(_DebugCom, string("Time Out atdl", 13))
    return 0
    
  repeat while rxFlag[_XBeeCom] <> oldRxFlag[_XBeeCom]
    FlushBuffer(_XBeeCom)
  localCount := ZeroPadString(@tempBuffer, Header#_XBeeSerialSize)
  if localCount > 0
    Com.str(_DebugCom, string(13, "DL = "))
    SafeBug(@tempBuffer, 8) 
  tempBuffer[Header#_XBeeSerialSize] := 0
  StringCopy(@slDestination, @tempBuffer)
  
  Com.str(_DebugCom, string(13, "End Command Mode"))
  repeat while rxFlag[_XBeeCom] <> oldRxFlag[_XBeeCom]
    FlushBuffer(_XBeeCom)
    
  localCount := cnt
  Com.str(_XBeeCom, string("ATCN "))
  Com.tx(_XBeeCom, 13) 
  repeat while rxFlag[_XBeeCom] == oldRxFlag[_XBeeCom] and Header#_XBeeTimeout => cnt - localCount
  if rxFlag[_XBeeCom] == oldRxFlag[_XBeeCom]
    Com.str(_DebugCom, string("Time Out atcn", 13))
    return 0

  repeat while rxFlag[_XBeeCom] <> oldRxFlag[_XBeeCom]
    FlushBuffer(_XBeeCom)
  result := 1

PRI FindXBeeSetting(localType) : xbeeNumber | localStartAddress[2], localIndex, localKnownSN[2]

  xbeeNumber := -1
  
  if localType == Header#_AttachedSerial
    localKnownSN[0] := @slAttached
    localKnownSN[1] := @shAttached
  else
    localKnownSN[0] := @slDestination
    localKnownSN[1] := @shDestination
    
  localStartAddress[0] := @slCoordinator
  localStartAddress[1] := @shCoordinator
  
  {Com.str(_DebugCom, string(13, "Lower known address = "))
  'Com.str(_DebugCom, string(13))
  Com.str(_DebugCom, localKnownSN[0])
  Com.str(_DebugCom, string(13, "Higher known address = "))
  'Com.str(_DebugCom, string(13))
  Com.str(_DebugCom, localKnownSN[1])
   }
  repeat localIndex from Header#_Coordinator to Header#_Broadcast
    'Com.str(_DebugCom, string(13, "Compared lower address = "))
    'Com.str(_DebugCom, localStartAddress[0] + (localIndex * (Header#_XBeeSerialSize + 1)))
    if strcomp(localStartAddress[0] + (localIndex * (Header#_XBeeSerialSize + 1)), localKnownSN[0])
      'Com.str(_DebugCom, string(13, "Lower addresses match, known high address = "))
      'Com.str(_DebugCom, localKnownSN[1])
      if strcomp(localStartAddress[1] + (localIndex * (Header#_XBeeSerialSize + 1)), localKnownSN[1])
        'Com.str(_DebugCom, string(13, "Higher addresses match, matching high address = ", 13))
        'Com.str(_DebugCom, localStartAddress[1] + (localIndex * (Header#_XBeeSerialSize + 1)))
        xbeeNumber := localIndex
        return xbeeNumber
      else
        Com.str(_DebugCom, string(13, "Strange . . . The lower addresses match but not the upper addresses.", 13))
        Com.str(_DebugCom, string(13, "bad high address = ", 13))
        Com.str(_DebugCom, localStartAddress[1] + (localIndex * (Header#_XBeeSerialSize + 1)))
     
PRI FlushBuffer(localBufferIndex) | localCharacter, localIndex, linesOut, previousWirelessCharacter

   if rxFlag[localBufferIndex] == oldRxFlag[localBufferIndex]                              
    Tbug(string(13, "No buffer data, rxFlag["))
    TbugDec(localBufferIndex)
    Tbug(string("] = "))
    TbugDec(rxFlag[localBufferIndex])
    return 0

  previousWirelessCharacter := 0
  localIndex := 0
  linesOut := linesToExpectCom[localBufferIndex]
  repeat while linesOut > 0
    if localIndex => Header#_LargeBufferSize
      Tbug(string(13, "tempBuffer full!", 13))
      Tbug(string("This shouldn't happen.", 13)) 
      quit
    localCharacter := Com.rxcheck(localBufferIndex)
    if localCharacter == -1
      Tbug(string(13, "rx buffer empty!!!", 13))
      Tbug(string("Data is missing!!!", 13))
      localCharacter := endChar
    tempBuffer[localIndex] := localCharacter
    
    if localBufferIndex == WirelessCom
      if localIndex == 0
        previousWirelessCharacter := localCharacter
      'elseif localIndex == 1 and previousWirelessCharacter == Header#_WirelessAck
       
        'if localCharacter == setCount[xbeeSettings[Header#_TargetSerial]]
        'acknowledgeFlag[xbeeSettings[Header#_TargetSerial]]++
      elseif localIndex == 4
       
        Com.tx(_XBeeCom, Header#_WirelessAck)
        ' check for missed transmission
        'setCount[xbeeSettings[Header#_AttachedSerial
        Com.tx(_XBeeCom, localCharacter)
        Com.tx(_XBeeCom, endChar)
    if localCharacter == endChar 
      linesOut--
    localIndex++
  tempBuffer[localIndex] := 0   ' is this needed?
  'Tbug(@tempBuffer)
  oldRxFlag[localBufferIndex]++
  SafeBug(@tempBuffer, localIndex)
 
  result := localIndex 

PUB TransmitString(sourceNumber, targetNumber, pointer) | size, localIndex, localCharacter[2], attempts, localBufferIndex, localCount, {
                                          } targetLetter, sourceLetter
'' String needs to terminate with a carriage return
'' There may be a zero after carriage return but it will not be transmitted.

  'Com.str(_XBeeCom, pointer)
  'return
  size := strsize(pointer)                              
                                                       

  sourceLetter := lookupz(sourceNumber: "a", "e", "h", "s")
  if sourceLetter < "s"
    sourceLetter := "s"
    Com.str(_DebugCom, string(13, "The source XBee letter was not found,"))
    Com.str(_DebugCom, string(13, "using the default of ", 34, "s", 34, ".", 13))
    waitcnt(clkfreq * 1 + cnt)
  targetLetter := lookupz(targetNumber: "a", "e", "h", "s")
  if targetLetter < "a"
    targetLetter := "a"
    Com.str(_DebugCom, string(13, "The target XBee letter was not found,"))
    Com.str(_DebugCom, string(13, "using the default of ", 34, "a", 34, ".", 13))
    waitcnt(clkfreq * 1 + cnt)

  
  if setCount[targetNumber] == 12 or setCount[targetNumber] == $FF
    setCount[targetNumber] += 2
  else
    setCount[targetNumber]++

  attempts := 0
  Com.str(_DebugCom, string(13, "TransmitString method", 13))
 
  acknowledgeFlag[targetNumber] := 0
  
  repeat
    Com.tx(_XBeeCom, Header#_StartOfHeader)
    Com.tx(_XBeeCom, Header#_StartOfText)
    Com.tx(_XBeeCom, targetLetter)             ' distination board
    Com.tx(_XBeeCom, sourceLetter)    
    Com.tx(_XBeeCom, setCount[targetNumber])
    Com.str(_XBeeCom, pointer)                       ' ** okay if all data is ASCII
    if byte[pointer + size - 1] <> 13
      Com.str(_DebugCom, string(13, "byte[pointer + size - 1] <> 13")) 
      Com.tx(_XBeeCom, 13)                        ' **Am I sure about this?
                                                      ' I want the transmission to end with a cairrage return
    localCount := cnt
    repeat while (acknowledgeFlag[targetNumber] == 0) and Header#_XBeeTimeoutRx => cnt - localCount
      'if rxFlag[WirelessCom] <> oldRxFlag[WirelessCom]    ' At least one of the devices needs this code
      '  FlushBuffer(WirelessCom)                          ' to prevent both devices waiting for acknowledgements.
    attempts++                                                                                                            
   
                
  while ((attempts < Header#_TxAttempts) and (acknowledgeFlag[targetNumber] == 0))
   
  if acknowledgeFlag[targetNumber] == 0
    '*100809*Beep.Bonk
   
    Com.str(_DebugCom, string(13, "tries = "))
    Com.dec(_DebugCom, attempts)
    Com.tx(_DebugCom, 13) 
   ' Com.str(_DebugCom, string(13, "tries = "))
   ' Com.dec(_DebugCom, attempts)
   
  else
    '*100809*Beep.BeeDeep
   
    Com.str(_DebugCom, string(13, "successful tx"))
    'Com.str(_DebugCom, string(13, "successful tx"))
 
  result := acknowledgeFlag[targetNumber]

PUB StringCopy(destinationPointer, sourcePointer) | localTemp

  localTemp := strsize(sourcePointer) + 1
  bytemove(destinationPointer, sourcePointer, localTemp) 
 
PUB ZeroPadString(localPtr, digits) : localDifference | localIndex, localSize

  {Tbug(string(13, "ZeroPadString method")) }
  localSize := strsize(localPtr)
  Tbug(string(13, "initial localSize = "))
  TbugDec(localSize)
  Tbug(string(13, "SafeBug(localPtr, digits + 2) = "))
  SafeBug(localPtr, digits + 2)
  Tbug(string(13, "byte[localPtr + localSize - 1] = "))
  TbugDec(byte[localPtr + localSize - 1])
  if byte[localPtr + localSize - 1] == 13 and localSize =< digits
    byte[localPtr + localSize - 1] := 0
    localSize--
    'Tbug(string(13, "final localSize = "))
    'TbugDec(localSize)
  localDifference := digits - localSize
  Tbug(string(13, "localDifference = "))
  TbugDec(localDifference)
  if localDifference > 0
    bytemove(localPtr + localDifference, localPtr, localSize + 1) ' move terminating zero with it
    repeat localIndex from 0 to (localDifference - 1)
      byte[localPtr + localIndex] := "0"   
  Tbug(string(13, "SafeBug(localPtr, digits + 2) = "))
  SafeBug(localPtr, digits + 2) 
  
PUB SafeBug(localPtr, localSize)

  repeat result from 0 to localSize - 1
    TbugTx(byte[localPtr + result])
      
PRI Tbug(localPtr)

  'Tv.str(localPtr)
  Com.str(_DebugCom, localPtr)

PRI TbugDec(localDec)

  'Tv.dec(localDec)
  Com.dec(_DebugCom, localDec)

PRI TbugTx(localCharacter)

  if (localCharacter > 31 and localCharacter < 127) or localCharacter == 13
    'Tv.out(localCharacter)
    Com.tx(_DebugCom, localCharacter)
  else
    'Tv.out(60)
    'Tv.out(36)
    Com.tx(_DebugCom, 60)
    Com.tx(_DebugCom, 36)
    TbugHex(localCharacter, 2)
    'Tv.out(62)
    Com.tx(_DebugCom, 62)
    
PRI TbugHex(localHex, localSize)
 
  'Tv.hex(localHex, localSize)
  Com.hex(_DebugCom, localHex, localSize)

PRI TbugBin(localBin, localSize)

  'Tv.bin(localBin, localSize)
  Com.bin(_DebugCom, localBin, localSize)
{
PRI Tbugt(localPtr)

  Tv.str(localPtr)
  

PRI TbugDect(localDec)

  Tv.dec(localDec)
}
DAT
                                     '         1         2         3         4         5
                                     '12345678901234567890123456789012345678901234567890123456789
spectrometerOutput1             byte "Spectro   , one, two, three, four, five, six", 13, 0 {45}
spectrometerOutput2             byte "Spectro   , seven, eight, nine, ten, eleven, twelve", 13, 0 {52.97}
spectrometerOutput3             byte "Spectro   , thirteen, fourteen, fifteen, sixteen", 13, 0 {49,146}
spectrometerOutput4             byte "Spectro   , seventeen, eighteen, nineteen, twenty", 13, 0 {50,196}
spectrometerOutput5             byte "Spectro   , twenty one, twenty two, twenty three", 13, 0 {49,245}
                                     '         1         2         3         4         5 
                                     '12345678901234567890123456789012345678901234567890123456789 
spectrometerOutput6             byte "Spectro   , twenty four, twenty five, twenty six", 13, 0 {49,294}
spectrometerOutput7             byte "Spectro   , twenty seven, twenty eight, twenty nine", 13, 0 {52,346}
spectrometerOutput8             byte "Spectro   , thirty, thirty one, thirty two, thirty three", 13, 0 {57,403}
spectrometerOutput9             byte "Spectro   , thirty four, thirty five, thirty six", 13, 0 {49,452}
spectrometerOutput10            byte "Spectro   , thirty seven, thirty eight, thirty nine", 13, 0 {52,504}
                                     '         1         2         3         4         5 
                                     '12345678901234567890123456789012345678901234567890123456789
xbee1Output1                    byte "XBee1     , one, two, three, four, five, six", 13, 0 {45}
xbee1Output2                    byte "XBee1     , seven, eight, nine, ten, eleven, twelve", 13, 0 {52.97}
xbee1Output3                    byte "XBee1     , thirteen, fourteen, fifteen, sixteen", 13, 0 {49,146}
xbee1Output4                    byte "XBee1     , seventeen, eighteen, nineteen, twenty", 13, 0 {50,196}
xbee1Output5                    byte "XBee1     , twenty one, twenty two, twenty three", 13, 0 {49,245}
                                     '         1         2         3         4         5 
                                     '12345678901234567890123456789012345678901234567890123456789 
xbee1Output6                    byte "XBee1     , twenty four, twenty five, twenty six", 13, 0 {49,294}
xbee1Output7                    byte "XBee1     , twenty seven, twenty eight, twenty nine", 13, 0 {52,346}
xbee1Output8                    byte "XBee1     , thirty, thirty one, thirty two, thirty three", 13, 0 {57,403}
xbee1Output9                    byte "XBee1     , thirty four, thirty five, thirty six", 13, 0 {49,452}
xbee1Output10                   byte "XBee1     , thirty seven, thirty eight, thirty nine", 13, 0 {52,504}
                                     '         1         2         3         4         5 
                                     '12345678901234567890123456789012345678901234567890123456789

shCoordinator byte "0013A200", 0                ' a
shBarcode     byte "0013A200", 0                ' e
shBackup      byte "0013A200", 0                ' h
shSam         byte "0013A200", 0                ' s
shFred        byte "0013A200", 0 
shBroadcast   byte "00000000", 0
slCoordinator byte "403BCAA8", 0
slBarcode     byte "400A27EB", 0
slBackup      byte "403BC58E", 0                ' h
slSam         byte "403DDA49", 0
slFred        byte "403DDA4A", 0
slBroadcast   byte "0000FFFF", 0
shAttached    byte 0[Header#_XBeeSerialSize + 1]
slAttached    byte 0[Header#_XBeeSerialSize + 1] 
shDestination byte 0[Header#_XBeeSerialSize + 1] 
slDestination byte 0[Header#_XBeeSerialSize + 1]
xAttached     byte 0[Header#_XBeeNameFieldSize]
xDestination  byte 0[Header#_XBeeNameFieldSize]
xbeeNames     byte "Coordinator", 0             ' a
              byte "Barcode", 0[5]            
              byte "Backup", 0[6]            
              byte "Sam", 0[9]            
              byte "Fred", 0[8]            
              byte "Broadcast", 0[3]            
                                            